'+--------------------------------------------------------------------------+
'|                               MagicBall                                  |
'|                                                                          |
'|             Example of 32-bit OpenGL layered splash screen               |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2008                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 10-16-2008 (MM-DD-YYYY)            |
'|                        Last revised : 10-16-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "MagicBall.exe"

#INCLUDE "GLDrawDIB.inc"

'------------------------------------------------------------------------------------------
' LOCAL section
'-----------------------------------------------------------------------------------------
%FRAME_SizeX = 256 '// The frame width
%FRAME_SizeY = 256 '// The frame height

GLOBAL ImageArray() AS LONG
GLOBAL gSphere, hGLDC, hGLRC AS LONG
GLOBAL mt() AS BBPTEXTURE

TYPE OVERLAPPED
    Internal AS DWORD
    InternalHigh AS DWORD
    offset AS DWORD
    OffsetHigh AS DWORD
    hEvent AS DWORD
END TYPE
DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION CreateFile LIB "KERNEL32.DLL" ALIAS "CreateFileA" (lpFileName AS ASCIIZ, BYVAL dwDesiredAccess AS DWORD, BYVAL dwShareMode AS DWORD, lpSecurityAttributes AS SECURITY_ATTRIBUTES, BYVAL dwCreationDisposition AS DWORD, _
                 BYVAL dwFlagsAndAttributes AS DWORD, BYVAL hTemplateFile AS DWORD) AS DWORD
DECLARE FUNCTION GetFileSize LIB "KERNEL32.DLL" ALIAS "GetFileSize" (BYVAL hFile AS DWORD, lpFileSizeHigh AS LONG) AS LONG
DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" () AS LONG
DECLARE FUNCTION ReadFile LIB "KERNEL32.DLL" ALIAS "ReadFile" (BYVAL hFile AS DWORD, lpBuffer AS ANY, BYVAL nNumberOfBytesToRead AS DWORD, lpNumberOfBytesRead AS DWORD, lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION SetFilePointer LIB "KERNEL32.DLL" ALIAS "SetFilePointer" (BYVAL hFile AS DWORD, BYVAL lDistanceToMove AS LONG, lpDistanceToMoveHigh AS LONG, BYVAL dwMoveMethod AS DWORD) AS LONG
    ' Enhanced sequential LINEINPUT
FUNCTION Bufin (zFileName AS ASCIIZ, nDone AS LONG) STATIC AS STRING
    DIM sCr AS STRING, sBuffer AS STRING
    DIM hFile AS LONG, nLocation AS LONG, nBufSize AS LONG, nBufPos AS LONG, nErrCode AS LONG, nRemaining AS LONG
    DIM nCr AS LONG, nSlop AS LONG, nReading AS LONG, nLenCr AS LONG, nSizeFile AS LONG, nSaveCr AS LONG
    LOCAL ByttesReaded AS LONG
    IF LEN(zFileName) THEN
       IF NOT nReading THEN
          nReading = -1: nDone = 0
          nLenCr = 0: sCr = CHR$(13)
          nCr = 0: nLocation = 0
          IF NOT ISFILE(zFileName) THEN GOTO BufEnd  ' Nothing to do
          hFile = CreateFile(zFileName, &H80000000&, &H00000001, BYVAL 0&, 4, &H00000080, BYVAL 0&)
          IF hFile = -1 THEN                ' -1 Fail to create the file
             nDone = GetLastError           ' Set the error code
             hFile = 0: nReading = 0        ' Reset handle number
             EXIT FUNCTION
          END IF
        ' Bytes count to be read
          nRemaining = GetFileSize(hFile, BYVAL 0&): IF nRemaining = -1 THEN nRemaining = 0
          nSizeFile = nRemaining                     ' Remember this
          IF nRemaining = 0 GOTO BufEnd              ' Nothing to read
          nBufSize = 16384
          sBuffer = SPACE$(nBufSize)
       END IF
       DO WHILE nRemaining                           ' While more in the file
          IF nCr = 0 THEN                            ' If no return was found
             IF nRemaining < nBufSize THEN           ' read only what remains.
                nBufSize = nRemaining                ' Resize the buffer.
                IF nBufSize < 1 THEN EXIT DO         ' Possible only if EOF 26.
                sBuffer = SPACE$(nBufSize)
             END IF

             ' Get the string data
             IF SetFilePointer(hFile, nLocation, BYVAL 0&, 0) > -1 THEN
                IF nBufSize AND ReadFile(hFile, BYVAL STRPTR(sBuffer), nBufSize, ByttesReaded, BYVAL 0&) = 0 THEN
                   nErrCode = GetLastError
                 END IF
             END IF

             nLocation = nLocation + nBufSize        ' Here we are.
             nBufPos = 1                             ' Start at the beginning
          END IF                                     ' of that bloc.
          DO                                         ' Walk through buffer.
             nCr = INSTR(nBufPos, sBuffer, sCr)      ' Look for a Return.
             IF nLenCr = 0 THEN                      ' Do this to read files with
                nLenCr = 1                           ' or without LF after CR.
                IF ASC(sBuffer, nCr + 1) = 10 THEN nLenCr = 2
             END IF
             IF nCr THEN                             ' We found one.
                nSaveCr = nCr                        ' Save where
                FUNCTION = MID$(sBuffer, nBufPos, nCr - nBufPos)
                nBufPos = nCr + nLenCr               ' In case of LF skip it
                EXIT FUNCTION                        ' all done for now.
             ELSE                                    ' Back up in the file.
              ' If we reached the end of file and no nCr
              ' was found, return what remains in the string.
                IF nLocation >= nSizeFile THEN
                 ' Assign function and trap ^Z
                   FUNCTION = RTRIM$(MID$(sBuffer, nSaveCr + nLenCr), CHR$(26))
                   nRemaining = nBufSize
                   EXIT DO
                END IF
              ' 05-06-1998 () were missing on each side of (nLenCr - 1)
                nSlop = nBufSize - nSaveCr - (nLenCr - 1) ' Calc buffer excess.
                nRemaining = nRemaining + nSlop           ' Calc file excess.
                nLocation = nLocation - nSlop
             END IF
          LOOP WHILE nCr                                 ' While more in buffer.
          nRemaining = nRemaining - nBufSize
          nSaveCr = 0
       LOOP
    END IF

    BufEnd:
    nReading = 0: nDone = -1: IF hFile THEN CALL CloseHandle(hFile)
    hFile = 0
END FUNCTION

'//DECLARE SUB skDebug LIB "SKENGINE.DLL" (BYVAL Msg$)
FUNCTION GLsphere() AS LONG
    LOCAL K, Done, ListSphere AS LONG, sBuf AS STRING
    LOCAL s1, s2, s3, edge AS SINGLE

    '// Load the sphere mesh
    ListSphere = glGenLists(1)
    CALL glNewlist(ListSphere, %GL_COMPILE)
    DO WHILE Done = 0
       INCR K
       sBuf = LTRIM$(Bufin("Encounter.bbm", Done))
       IF ASC(LTRIM$(sBuf)) = 39 THEN sBuf = "" ' "'"
       IF LEN(sBuf) THEN

          IF (K mod 8) = 0 THEN ' <--------------- Change to either 8, 11, 13, 15, 21
             s1 = VAL(PARSE$(sBuf, 1))
             s2 = VAL(PARSE$(sBuf, 2))
             s3 = VAL(PARSE$(sBuf, 3))
             CALL glVertex3f(s1, s2, s3)

             CALL glPushMatrix()
                edge = 0.15
                CALL glBegin(%GL_QUADS)
                   CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f(-edge + s1,-edge + s2, s3)
                   CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f( edge + s1,-edge + s2, s3)
                   CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f( edge + s1, edge + s2, s3)
                   CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f(-edge + s1, edge + s2, s3)
                CALL glEnd()
             CALL glPopMatrix()

          END IF

       END IF
    LOOP

    CALL glEndList()
    FUNCTION = ListSphere
END FUNCTION

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WNDCLASSEX
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS DWORD
'
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZMAGICBALL"
'
   ' hMutex = CreateMutex(BYVAL %Null, 0, zClass)
   ' IF hMutex THEN
   '    IF GetLastError = %ERROR_ALREADY_EXISTS THEN
   '       DO
   '          hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
   '          WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
   '       LOOP
   '       IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
   '       CALL SetForeGroundWindow(hFound)
   '       FUNCTION = 0
   '       EXIT FUNCTION
   '    END IF
   ' END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(GetModuleHandle(""), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0
       wc.hInstance     = GetModuleHandle("")
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

'   // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = %WS_EX_LAYERED OR %WS_EX_TOPMOST OR %WS_EX_TOOLWINDOW
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP
'
       CALL SetRect(rc, 0, 0, %FRAME_SizeX, %FRAME_SizeY)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = EXE.Name$
       hMain = CreateWindowEx(dwExStyle, _            ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN

'         // The OpenGL stuff
          CALL CreateGLcontext(300, 300, hGLDC, hGLRC)
          DIM mt(1 TO 2) AS BBPTEXTURE
          mt(1).FullName = EXE.Path$ + "Bookmark.png":   mt(1).ID = 1: mt(1).Square = 0
          CALL MakeMultipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)
          CALL glBindTexture(%GL_TEXTURE_2D, mt(1).Texture)

          DIM ImageArray(1 TO 5)
          CALL SetImage(hMain)
          CALL ShowWindow(hMain, %SW_SHOW)

gSphere = GLsphere()
          CALL SetTimer(hMain, 1, 30, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
          WEND
          CALL KillTimer(hMain, 1)
CALL glDeleteLists(gSphere, 1)

          '//FreeUp resources
          CALL DestroyGLresources(hGLDC, hGLRC)
          CALL DestroyTexture()
          FOR x = LBOUND(ImageArray) TO UBOUND(ImageArray)
              IF ImageArray(x) THEN GdipDisposeImage(ImageArray(x)): ImageArray(x) = 0
          NEXT

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

    SELECT CASE LONG Msg

    CASE %WM_KEYDOWN
         IF wParam = &H1B& THEN '// VK_ESCAPE
            CALL DestroyWindow(hWnd)
         END IF

    CASE %WM_TIMER
         CALL SetImage(hWnd)

    CASE %WM_NCHITTEST
         FUNCTION = %HTCAPTION: EXIT FUNCTION

    CASE %WM_DESTROY
         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION
    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
    'FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB SetImage(BYVAL hWnd AS LONG)
    LOCAL graphics, DesktopDC, Img, imgW, imgH, ImgAttr, x, y AS LONG
    LOCAL rw AS RECT
    LOCAL bf AS BLENDFUNCTION
    LOCAL lp, ptSrc AS POINTAPI
    LOCAL lpSize AS SIZEL
    LOCAL ghBmp, ghMemDC AS LONG

    STATIC xMove3, FlipMove3 AS LONG

    CALL GetWindowRect(hWnd, rw)
    lpSize.Cx = rw.nRight - rw.nLeft: lpSize.Cy = rw.nBottom - rw.nTop
    lp.X = rw.nLeft: lp.Y = rw.nTop

    DesktopDC = GetDC(0)

    '// Draw active frame to new memory DC
    ghMemDC = CreateCompatibleDC(DesktopDC)
    ghBmp = zCreateDIBSection(DesktopDC, lpSize.Cx, lpSize.CY, 32)
    CALL SelectObject(ghMemDC, ghBmp)

'   // Draw OpenGL scene to the bottom of z-order
    CALL DrawTheScene()
    CALL wglMakeCurrent(hGLDC, hGLRC)
    CALL wglSwapBuffers(hGLDC)
    CALL DrawAndSetupAlphaChannel()
    CALL BitBlt(ghMemDC, -22, 19, lpSize.Cx, lpSize.CY, hGLDC, 0, 0, %SRCCOPY)

    IF GdipCreateFromHDC(ghMemDC, graphics) = 0 THEN
       CALL GdipSetInterpolationMode(graphics, 2)
       IF ImageArray(1) = 0 THEN
          IF GdipLoadImageFromFile((UCODE$(EXE.Path$ + "MagicBall.png")), Img) = 0 THEN ImageArray(1) = Img
       END IF
       Img = ImageArray(1)
       IF Img THEN
          CALL zGetImageSize(Img, imgW, imgH)
          CALL GdipDrawImageRectRectI(graphics, Img, 0, 0, imgW, imgH, 0, 0, imgW, imgH, 2, ImgAttr)
       END IF

       CALL GdipDeleteGraphics(graphics)
    END IF

    bf.BlendOp             = %AC_SRC_OVER
    bf.BlendFlags          = 0
    bf.AlphaFormat         = %AC_SRC_ALPHA '// Use source alpha
    bf.SourceConstantAlpha = 255 '//alpha

    CALL UpdateLayeredWindow (hWnd, DesktopDC, lp, lpSize, ghMemDC, ptSrc, 0, bf, &H00000002) ' %ULW_ALPHA)

    CALL DeleteObject(ghBmp)
    CALL DeleteDC(ghMemDC)
    CALL ReleaseDC(0, DesktopDC)
END SUB

SUB DrawTheScene() ' See MSDN documentation for the use of the OpenGL API

    STATIC xrot AS SINGLE

    CALL glClearColor(0.0, 0.0, 0.0, 0.0)
    CALL glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)

    CALL glLoadIdentity()

    CALL glTranslatef(0.0, 0.0, -58.0)

    CALL glRotatef(-xrot, 0.0, 1.0, 0.0) ' Rotate on the X axis

    CALL glPushMatrix()
         CALL glColor4ub(255,255,255,128)
         CALL glCallList(gSphere)
    CALL glPopMatrix()

    CALL glPushMatrix()
         CALL glRotatef(xrot, 0.0, -1.0, 0.0) ' Rotate on the X axis
         CALL glColor4ub(255,255,255,128)
         CALL glCallList(gSphere)
    CALL glPopMatrix()

    xrot += 1 ' <------ Rotation speed

END SUB

FUNCTION Rgb2Gray ALIAS "Rgb2Gray" (BYVAL RGBValue AS DWORD) EXPORT AS DWORD

    !XOR ESI, ESI
    !XOR EDX, EDX
    !MOV ECX, RGBValue

  ' Red
    !MOV EAX, 19595
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

  ' Green
    !MOV EAX, 38470
    !SHR ECX, 8
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

  ' Blue
    !MOV EAX, 7471
    !SHR ECX, 8
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

    !SHR ESI, 16
    !MOV EDX, ESI

  ' Put Gray Value to a DWORD (0GGG)
    !XOR EAX, EAX
    !OR AL, DL
    !SHL EAX, 8
    !OR AL, DL
    !SHL EAX, 8
    !OR AL, DL

    !MOV FUNCTION, EAX

END FUNCTION

SUB DrawAndSetupAlphaChannel()
'   // We must do this to be compatible with BitBlt
'   // We compute a fake alpha channel based on color conversion to shade of gray
    LOCAL pBits AS BYTE PTR, bm AS BITMAP, P AS LONG
    CALL GetObject(GetCurrentObject(hGLDC, 7), SIZEOF(bm), bm)
    pBits = bm.bmBits
    FOR P = (bm.bmWidth * bm.bmHeight) TO 1 STEP - 1
        Alpha& = Rgb2Gray(RGB(@pBits[2],@pBits[1],@pBits[0])) AND &H000000FF???
        '@pBits[3] = MIN&(Alpha& * 255, 255)
        IF Alpha& = 0 THEN
           @pBits[3] = 0
        ELSE
           @pBits[3] = 255
        END IF
        pBits = pBits + 4
    NEXT
END SUB

FUNCTION zSetupPixelFormat(BYVAL hDC AS LONG) AS LONG
    LOCAL pfd AS PIXELFORMATDESCRIPTOR
    LOCAL pixelformat AS LONG
    LOCAL lRet AS LONG

    lRet = %TRUE

    pfd.nSize      = SIZEOF(pfd)
    pfd.nVersion   = 1
    pfd.dwFlags    = %PFD_SUPPORT_OPENGL OR %PFD_DRAW_TO_BITMAP OR %PFD_SUPPORT_GDI
    pfd.iPixelType = %PFD_TYPE_RGBA

    pfd.cColorBits = 32
    pfd.cDepthBits = 32

    pixelformat = ChoosePixelFormat(hDC, pfd)

    IF pixelformat THEN
       IF SetPixelFormat(hDC, pixelformat, pfd) = 0 THEN lRet = %FALSE
    ELSE
       lRet = %FALSE
    END IF

    FUNCTION = lRet
END FUNCTION

SUB setGLPerspective(fovy  AS SINGLE, nAspect AS SINGLE,_
                     zNear AS SINGLE, zFar    AS SINGLE)
    LOCAL xmin!, xmax!, ymin!, ymax!
    ymax =  zNear * TAN(fovy * 0.00872664626)
    ymin = -ymax
    xmin =  ymin * nAspect
    xmax =  ymax * nAspect
    CALL glFrustum(xmin, xmax, ymin, ymax, zNear, zFar)
END SUB

FUNCTION CreateGLcontext(BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYREF hGLDC AS LONG, BYREF hGLRC AS LONG) AS LONG
    LOCAL nRet, DesktopDC, hGLBMP, Done AS LONG, sBuf AS STRING
    IF nWidth > 0 AND nHeight > 0 THEN
       DesktopDC = GetDC(0)
       hGLDC = CreateCompatibleDC(DesktopDC)
       hGLBMP = zCreateDIBSection(DesktopDC, nWidth, nHeight, 32)
       CALL SelectObject(hGLDC, hGLBMP)
       CALL ReleaseDC(0, DesktopDC)
       IF hGLBMP THEN
          IF zSetupPixelFormat(hGLDC) THEN
            hGLRC = wglCreateContext(hGLDC)
            IF hGLRC THEN
               IF wglMakeCurrent(hGLDC, hGLRC) THEN

                  CALL glClearColor(0.0, 0.0, 0.0, 0.0)

                  CALL glViewport(0, 0, nWidth, nHeight)

                  CALL glMatrixMode(%GL_PROJECTION)
                  CALL glLoadIdentity()
                  CALL setGLPerspective(7.5, nWidth / nHeight, 1.0, 100.0)
                  CALL glMatrixMode(%GL_MODELVIEW)

                  CALL glEnable(%GL_TEXTURE_2D)

                  nRet = -1

               END IF
            END IF
          END IF
       END IF
    END IF
    FUNCTION = nRet
END FUNCTION

SUB DestroyGLresources(BYREF hGLDC AS LONG, BYREF hGLRC AS LONG)
    IF hGLRC THEN
       CALL wglMakeCurrent(hGLDC, 0)
       CALL wglDeleteContext(hGLRC): hGLRC = 0
    END IF
    IF hGLDC THEN
       CALL DeleteObject(GetCurrentObject(hGLDC, %OBJ_BITMAP)) ' Delete the memory bitmap
       CALL DeleteDC(hGLDC): hGLDC = 0
    END IF
END SUB

SUB DestroyTexture()
    LOCAL K, mtCount, OkDelete AS LONG
    mtCount = UBOUND(mt()) - LBOUND(mt()) + 1
    IF mtCount THEN
       DIM Texture(1 TO mtCount) AS LONG
       FOR K = 1 TO mtCount
           Texture(K) = mt(k).Texture: IF Texture(K) THEN OkDelete = -1
       NEXT
       IF OkDelete THEN CALL glDeleteTextures(mtCount, Texture(1))
    END IF
END SUB

